//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Models/ParticleCompositionItem.h
//! @brief     Defines class ParticleCompositionItem
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_MODELS_PARTICLECOMPOSITIONITEM_H
#define BORNAGAIN_GUI_MODELS_PARTICLECOMPOSITIONITEM_H

#include "GUI/Models/ItemWithParticles.h"
#include "Sample/Particle/ParticleComposition.h"

class VectorItem;

class BA_CORE_API_ ParticleCompositionItem : public ItemWithParticles {
public:
    static const QString T_PARTICLES;
    ParticleCompositionItem();

    std::unique_ptr<ParticleComposition> createParticleComposition() const;
};

#endif // BORNAGAIN_GUI_MODELS_PARTICLECOMPOSITIONITEM_H
