#include "Resample/Coherence/FFSum.h"
#include "Resample/FFCompute/ComputeBA.h"
#include "Sample/HardParticle/FormFactorFullSphere.h"
#include "Tests/GTestWrapper/google_test.h"

class CoherentFFSumTest : public ::testing::Test {
};

TEST_F(CoherentFFSumTest, RelAbundance)
{
    const double epsilon = 1e-12;
    FormFactorFullSphere ff(5.0);
    CoherentFFTerm part(new ComputeBA(ff), 1.);
    CoherentFFSum ffw(1.0, {part});
    EXPECT_EQ(1.0, ffw.relativeAbundance());
    EXPECT_EQ(5.0, ffw.radialExtension());
    ffw.scaleRelativeAbundance(2.0);
    EXPECT_NEAR(0.5, ffw.relativeAbundance(), epsilon);
    EXPECT_THROW(ffw.scaleRelativeAbundance(0.0), std::runtime_error);
    EXPECT_EQ(5.0, ffw.radialExtension());
}
